package cviceni1;

import java.net.*;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.InputStreamReader;
import java.io.BufferedWriter;
import java.io.BufferedReader;

/**
 *
 * <p>Title: Jednoduchý HTTP Client</p>
 *
 * <p>Description: Trida slouzi jako ukazka jak pomoci Socket rozhrani stahnout textovy soubor z www serveru</p>
 * @author Lumír Návrat
 * @version 1.0
 */
public class HTTPURLConnectionClient {

  /**
    * Metoda se pripoji na server a stahne z nej pozadovanou stranku
    * @param server String jmeno www serveru, ze ktereho chceme soubor stahnout
    * @param pageAdress String cesta a jmeno stranky, kterou chceme stahnout
    * @return String pokud vse uspesne probehlo tak vrati zdrojovy kod HTML stranky
    */
   public String getHTMLPage(String pageAdress) {
     // Pomocna promenna, do ktere si ukladame postupne kazdy radek odpovedi ze serveru
     StringBuffer page = new StringBuffer();

     try {
       //Otevreme si spojeni s www serverem
       HttpURLConnection s = (HttpURLConnection) (new URL(pageAdress).openConnection());

       //Obdobne si obalime i vstupni stream, ve kterem k nam dorazi data s odpovedi ze serveru.
       BufferedReader br = new BufferedReader(new InputStreamReader(s.getInputStream()));
       //aktualne nacteny jeden radek HTTP odpovedi
       String line = br.readLine();
       //postupne nacitame jeden radek za druhym, dokud mame co cist.
       while (line != null) {
         //vlozime radek do naseho bufferu pro pozdejsi vypis
         page.append(line);
         //nacteme dalsi radek
         line = br.readLine();
       }
       //uzavreme socket, jelikoz s nim uz nechceme pracovat
       s.disconnect();
     } catch(UnknownHostException ex) {
       System.err.println("Adresa www serveru neexistuje");
     } catch(IOException ex) {
       System.err.println("Nastala chyba pri komunikaci");
     }
     return page.toString();
  }

/**
 * Spousti clienta
 * @param args String[]
 */
  public static void main(String[] args) {
    HTTPURLConnectionClient httpurlconnectionclient = new HTTPURLConnectionClient();
    String urladdress = "http://www.cs.vsb.cz";
    if (args.length >= 1) {
      urladdress = args[0];
    }
    System.out.println(httpurlconnectionclient.getHTMLPage(urladdress));
  }
}
