package cviceni1;

import java.io.IOException;
import java.net.URL;

import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JButton;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.*;
import javax.swing.ScrollPaneConstants;

public class MainFrame extends JFrame implements HyperlinkListener {
  JPanel contentPane;
  BorderLayout borderLayout = new BorderLayout();
  JEditorPane webBrowser = new JEditorPane();
  JPanel addressPanel = new JPanel();
  JTextField addressTextField = new JTextField();
  JButton goButton = new JButton();
  HTMLEditorKit htmlEditorKit = new HTMLEditorKit();
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane editorScrollPane = null;

  public MainFrame() {
    try {
      setDefaultCloseOperation(EXIT_ON_CLOSE);
      jbInit();
    } catch(Exception exception) {
      exception.printStackTrace();
    }
  }

  /**
   * Inicializace komponent.
   *
   * @throws java.lang.Exception
   */
  private void jbInit() throws Exception {
    contentPane = (JPanel)getContentPane();
    contentPane.setLayout(borderLayout);
    setSize(new Dimension(400, 300));
    setTitle("Simple HTML Browser");
    addressPanel.setLayout(borderLayout1);
    addressTextField.setText("http://www.cs.vsb.cz");
    addressTextField.setHorizontalAlignment(SwingConstants.LEFT);
    goButton.setHorizontalAlignment(SwingConstants.CENTER);
    goButton.setText("Zobrazit");
    goButton.addActionListener(new MainFrame_goButton_actionAdapter(this));
    webBrowser.setEditorKit(htmlEditorKit);

    webBrowser.setEditable(false);
    changePage(new URL(addressTextField.getText()));
    webBrowser.addHyperlinkListener(this);

    editorScrollPane = new JScrollPane(webBrowser);
    editorScrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
    editorScrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
    editorScrollPane.setPreferredSize(new Dimension(250, 145));
    editorScrollPane.setMinimumSize(new Dimension(10, 10));
    contentPane.add(addressPanel, java.awt.BorderLayout.NORTH);
    contentPane.add(editorScrollPane, java.awt.BorderLayout.CENTER);
    addressPanel.add(addressTextField, java.awt.BorderLayout.CENTER);
    addressPanel.add(goButton, java.awt.BorderLayout.EAST);
  }

  /**
   * Reakce na udalost kliknuti na odkaz
   * @param e the event responsible for the update
   */
  public void hyperlinkUpdate(HyperlinkEvent e) {
    if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
    {
      JEditorPane pane = (JEditorPane)e.getSource();
      if(e instanceof HTMLFrameHyperlinkEvent) {
        HTMLFrameHyperlinkEvent evt = (HTMLFrameHyperlinkEvent)e;
        HTMLDocument doc = (HTMLDocument)pane.getDocument();
        doc.processHTMLFrameHyperlinkEvent(evt);
      } else {
        changePage(e.getURL());
      }
    }
  }

  /**
   * Provede nahrazeni stranky v panelu
   * @param url URL nova adresa dokumentu, ktery chceme zobrazit
   */
  private void changePage(URL url) {
    try {
      webBrowser.setPage(url);
    } catch(IOException ex) {
    }
  }

  /**
   * Provede záměnu zobrazené stránky
   * @param e ActionEvent
   */
  public void goButton_actionPerformed(ActionEvent e) {
    URL url = null;
    try {
      url = new URL(addressTextField.getText());
    } catch(MalformedURLException ex) {
    }
    changePage(url);
  }

}

/**
 * Navrhový vzor Adapter pro obsluhu udalosti kliknutí na tlačítko Zobrazit
 * @author Lumír Návrat
 * @version 1.0
 */
class MainFrame_goButton_actionAdapter implements ActionListener {
  private MainFrame adaptee;
  MainFrame_goButton_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.goButton_actionPerformed(e);
  }
}
